\ R2000.F  -- RABBIT 2000 PORT INTERFACE
\ (C) 2000 DOUGLAS BEATTIE JR.
\ ALL ORIGINAL MATERIAL

INCLUDE C:\SWIFTFORTH\LIB\OPTIONS\WIN32\PORTIO.F

: P! PC! ;
: P@ PC@ ;

( serial communication experiment -- 8250/16450 )

: (Y/N)  KEY 32 OR 121 = ;

HEX

2F8 CONSTANT COM2

COM2 0 + DUP
         CONSTANT THR
         CONSTANT RDR   ( txm/rcx registers )
COM2 0 + CONSTANT BRDL  ( baud rate divisor LSB )
COM2 1 + CONSTANT BRDH  ( baud rate divisor MSB )
COM2 3 + CONSTANT LCR   ( line control register )
COM2 4 + CONSTANT MDC   ( modem control )
COM2 5 + CONSTANT LST   ( line status )
COM2 6 + CONSTANT MSR   ( modem status register )

(  initialize for communication with Rabbit 2000, basic mechanism )

HEX

: set2400
    80 LCR P!     ( activate baud load )
    0 BRDH P!  ( do MSB )
    30 BRDL P!  ( and LSB )
    ;

: set8n1 ( -- )
    03 LCR P!
    ;

: txOK ( -- t )
    LST P@
    20 AND
    20 =
    ;

: rxOK ( -- t ) LST P@ 1 AND ;

: xEmit ( c -- ) BEGIN txOK UNTIL ( IF ) THR P! ( THEN ) ;

: xKey  ( -- c ) rxOK IF RDR P@ THEN ;

: RESET  01 MDC P! 200 MS 00 MDC P! 500 MS ;

: INITIALIZE set2400  set8n1 RESET ;

DECIMAL 50 VALUE TD

:  TRIPLET ( hibyt lobyt datum -- )
    SWAP ROT
    xEMIT ( TD MS )
    xEMIT ( TD MS )
    xEMIT ( TD MS )
    ;

HEX

: TESTIT
    /PORTS
    INITIALIZE
    80 0E 20 TRIPLET
    80 0E 30 TRIPLET
    80 0E 20 TRIPLET
    PORTS/
    ;
 INCLUDE \TRIPL
 INCLUDE \RAPP
