\ TRIPLET LOADER FOR INTEL HEX FILES
\ (C) 2000 DOUGLAS BEATTIE JR.
\ ALL ORIGINAL MATERIAL

\ REQUIRES R2000.F ALREADY LOADED
\ SOURCE PATH IS ASSUMED TO BE \CAML\CAMEL80.HEX

FALSE VALUE DEBUG

\ TRUE TO DEBUG   \ uncomment this line for debugging.

\     the following 3 words are not used, but might be useful if
\     you want to port this back to PYGMY Forth, where it
\     all started...

{ ===

CREATE $FNAME-BUFR 32 ALLOT
: ZERO-$FNAME-BUFR
    $FNAME-BUFR DUP 32 + SWAP DO 0 I C! LOOP ;

: INPFILE 3 HANDLE @ ;

: OPEN-INPUT-FILE
  ZERO-$FNAME-BUFR
  $80 ( is address of DOS command-line buffer)
  SKIPWHITE
  $FNAME-BUFR GET-ARG

  $FNAME-BUFR 3 OPEN
  INPFILE >BOF
  ;
  === }

\ open input file and assign file-id to INPFILE
0 VALUE INPFILE

: OPEN-INPUT-FILE
    S" \CAML\CAMEL80.HEX"    \ hard-code the input filename for now...
    R/W BIN OPEN-FILE
    ABORT" FILE OPEN ERROR."
    TO INPFILE      \ assign file-id to INPFILE
    ;

: WRAPUP
    INPFILE CLOSE-FILE  ( And wrap-up I/O )
    DROP
    ;

( okay, now for the good stuff... )
CREATE INPBUFR 32 ALLOT

: GET-DATA ( nbytes -- )
    INPBUFR SWAP
    INPFILE READ-FILE
    ABORT" FILE READ ERROR (GET-DATA)"
    DROP        \ ?? discard count  -- shouldn't we??
  ;

: EOF?
    INPFILE FILE-POSITION   ABORT" FILE ERROR (FILE-POSITION)"
    INPFILE FILE-SIZE       ABORT" FILE ERROR (FILE-SIZE)"
    D=
    ;

\ Intel HEX records always begin with ":" ( a colon)
: FIND-HEX-RECORD
    BEGIN
        1 GET-DATA  \ read one byte
        INPBUFR C@  \ grab from buffer
        [CHAR] : =  \ we're looking for colon ":"
        EOF? OR     \ or end-of-file
    UNTIL
    ;

0 VALUE REC-LENGTH  \ length of HEX record
0 VALUE REC-TYPE    \ record type
0 VALUE LOAD-ADDR   \ load address

: LSB/MSB ( word16 -- lobyte hibyte )
    DUP FF AND
    SWAP 8 RSHIFT
    ;

: verify-data ( n -- n )   DUP 5 SPACES LOAD-ADDR . . CR ;

\ redfine xEmit for debugging hook
: xEmit
DEBUG IF    .
ELSE
    xEmit ( TD MS )
THEN ;

: send-triplet ( n -- )
DEBUG IF 7 SPACES
THEN
    LOAD-ADDR LSB/MSB   \ ( n lsb msb )
    xEmit               \ ( n lsb ) MSB transmitted
    xEmit               \ ( n )     LSB transmitted
    xEmit               \           Datum transmitted
DEBUG IF CR CR
THEN
    ;

: RD-HEX ( ndigits -- x )
    0 0 INPBUFR     \ prepare for >NUMBER, (n ud caddr )
    3 ROLL          \ ( ud caddr n ) okay, ready.
    >NUMBER         \ ( ud-lo ud-hi caddr n )
    DROP DROP DROP  \ keep only low-order cell of result
    ;

: READ-HEADER-INFO
  2 GET-DATA     2 RD-HEX   TO REC-LENGTH
  4 GET-DATA     4 RD-HEX   TO LOAD-ADDR
  2 GET-DATA     2 RD-HEX   TO REC-TYPE
  ;

FALSE VALUE FINAL-RECORD

: SEND-HEX-RECORD
    FALSE TO FINAL-RECORD
    HEX  ( ..Must be in Hexadecimal mode! )
    FIND-HEX-RECORD EOF? IF EXIT THEN
    READ-HEADER-INFO
    REC-LENGTH DUP 0 > IF
        0 DO
            2 GET-DATA 2 RD-HEX
DEBUG IF    verify-data
THEN
            send-triplet        \  <<<<============================<<<<
            LOAD-ADDR 1+ TO LOAD-ADDR
            LOOP
        ELSE      ( zero-length record )
DEBUG IF    ." FINAL ADDRESS SEEN:" LOAD-ADDR . CR
THEN
            TRUE TO FINAL-RECORD
            DROP
        THEN
        ;

\ rewind to Beginning Of File
: >BOF
    0 0 INPFILE
    REPOSITION-FILE
    ABORT" CAN'T REWIND FILE!"
    ;

\ : MYAPP
: UPLOAD-HEX-FILE
    OPEN-INPUT-FILE
\   CR $FNAME-BUFR COUNT TYPE ."  OPENED." CR
\   INPBUFR 1 INPFILE FILE-READ  ( Dummy read to jumpstart "?" )
\   ( INPFILE ) >BOF       ( position to Beginning-Of-File )
    BEGIN
        SEND-HEX-RECORD
DEBUG IF KEY DROP       \ wait for key between records
THEN
        FINAL-RECORD EOF? OR    \ until final hex record or end-of-file
        UNTIL
    WRAPUP
    ;



\ debugging tool:

: EMPTY-STACK DEPTH 0 ?DO DROP LOOP ;
